#! /usr/bin/perl -w
print "Content-type: text/html\n\n";

if ($ENV{"REQUEST_METHOD"} eq "POST") {
  read(STDIN, $datastring, $ENV{"CONTENT_LENGTH"});		
}
elsif (exists $ENV{"REQUEST_METHOD"}) {		# data from GET transaction (or HEAD or other)
  $datastring = $ENV{"QUERY_STRING"};
}
else {
  print "Offline execution detected\n";
  print "Please enter some data.\n";
  $datastring = <>;
  chomp $datastring;
  print "== data accepted == HTML output follows ==\n\n";
}

###decode######################################################
$datastring =~s/%0D%0A/\n/g;                    			#step to deal with line
																											#breaks in text areas
@nameValuePairs = split(/&/, $datastring);						#step 1
foreach $pair (@nameValuePairs) {
  ($name, $value) = split(/=/, $pair);								#step 2
  
  $name =~tr/+/ /;                                 		#step 3
  $name =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg; 		#step 3
  $value =~tr/+/ /;                                		#step 3
  $value =~s/%([\da-fA-F]{2})/pack("C",hex($1))/eg;		#step 3
  
  if(exists $formHash{$name}) {												#improved step 4,
    $formHash{$name} = $formHash{$name}.";".$value;		#now handles multiple
  }																										#select menus
  else {
    $formHash{$name} = $value;
  }   	
}
###done decoding###############################################

$userDir = "users/";  # Location of user files.
																		  
### app logic #################################################
if($formHash{"request"} eq "new_user") {
	&new_user;
}
else {
	&welcome_page;
}
### end app logic #############################################


#####################################################################
sub welcome_page {
 my ($message) = @_;
 if(!$message){$message = "Please sign up.";} # The default message
 print <<PAGE;
 <html><head><title>Sign up page</title></head><body>
   <h2>$message</h2> 

    <form action="$ENV{'SCRIPT_NAME'}" method="GET">
     All fields are required.  Your password will be emailed to you.
     <table>
     <tr><td align="right">Desired Username:</td>
      <td><input type="text" name="username" value="$formHash{'username'}" size="20"/></td>
     </tr>
     <tr><td align="right">Name:</td>
      <td><input type="text" name="name" value="$formHash{'name'}" size="20"/></td>
     </tr>
     <tr><td align="right">Email:</td>
      <td><input type="text" name="email" value="$formHash{'email'}" size="20"/></td>
     </tr>
      </table>
     <input type="hidden" name="request" value="new_user"/>
     <input type="submit" value="Sign up"/>
    </form>
 </body></html>
PAGE
}

#####################################################################
sub new_user {
  my @required_form_keys = ("username", "name", "email");
  foreach $key (@required_form_keys) {
    if($formHash{$key} eq "") {
      &welcome_page("You did not fill in the $key field.");
      exit;
    }
  }
  
  my $new_user = lc $formHash{"username"};
  if($new_user =~ /\W/){  ### check for nonalphanumeric characters
    &welcome_page("You may use only alphanumeric characters in the username.");
    exit;
  }
  if(-e "$userDir$new_user.user"){  # check if username already is use
    &welcome_page("Sorry, user already exists. Please choose another username.");
    exit;
  }

  my $temp_pass = &generate_random_string(8);
  my %userHash = (
    "username" => $new_user,
    "password" => $temp_pass,
    "name" => $formHash{"name"},
    "email" => $formHash{"email"},
    "create_time" => time,  ### Current time as an integer
    "ever_logged_in" => 0   
  );
  
  &write_user_file($userDir, $new_user, %userHash);

  use Mail::Sendmail;
  
  $adminEmail = "admin\@uweb.edu"; 	#This should probably be set as a global constant.
  
  $smtp_server = "localhost";     	#This is if the local host is also an smtp server.
  																	#Otherwise, this should be the address of a SPTP server
  																	#that will accept outgoing mail from the web server.
  
  my $message = "Your temporary password is $temp_pass.\n";
 
  my %mail = (
    "To" => $formHash{"email"},
    "From" => $adminEmail,
    "Bcc" => $adminEmail,
    "Subject" => "Your new account",
    "message" => $message,
    "smtp" => $smtp_server
  );
 
  sendmail(%mail) or &errorPage("Failure to send email.");

  print <<PAGE;
 <html><head><title>Sign up page</title></head><body>
   <h2>Your new user information is added successfully. 
       You have been emailed your temporary password.
       Please log in within 24 hours or your new account will be deleted.</h2> 
     <a href="hypotheticalloginpage.cgi">To log in.</a>
 </body></html>
PAGE
}

#####################################################################
sub write_user_file {
	my ($dir , $file_name , %userHash) = @_;
	
	my $file = $dir.$file_name.".user";
	open (F, ">$file") or &errorPage("Error Creating user file.");
	foreach $item (keys %userHash) {
		print F "$item=$userHash{$item}\n";
	}
	close(F);
}


#####################################################################
sub generate_random_string {
  my $length = $_[0];
  my $result = "";
  my @chars = (0..9, 'a'..'z', 'A'..'Z');
  my $which;
  for($i = 1 ; $i <= $length ; $i++) {
  	$which=int rand 62;
    $result = $result . $chars[$which];
  }
  return $result;
}

#####################################################################
sub errorPage {
 my $message = $_[0];  # optional message parameter
 
 print<<ALL;
 <html><head><title>Server Error</title></head><body>
  <h2>Server Error Encountered</h2>
  $message 
  
  If the problem persists, please notify the <a href="mailto:admin\@uweb.edu">webmaster</a>.
 </body></html>
ALL
 
exit;   # terminate program since failure to open data file
}

